unit uFrmElegantThread;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, uTestThread, uElegantThread;

type
  TFrmElegantThread = class(TForm)
    memMsg: TMemo;
    btnStart: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
  private
    { Private declarations }

    FTaskCode: integer;

    FDataThread: TElegantThread;
    FTestThread1: TTestThread;
    FTestThread2: TTestThread;

    procedure DispMsg(AMsg: string);
    procedure OnThreadMsg(AMsg: String);
    procedure OnTest(Sender: TTestThread);

  public
    { Public declarations }
  end;

var
  FrmElegantThread: TFrmElegantThread;

implementation

{$R *.dfm}
{ TFrmElegantThread }

procedure TFrmElegantThread.btnStartClick(Sender: TObject);
begin
  FTaskCode := 0;
  FTestThread1.StartThread;
  FTestThread2.StartThread;
end;

procedure TFrmElegantThread.DispMsg(AMsg: String);
begin
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmElegantThread.FormCreate(Sender: TObject);
begin

  FDataThread := TElegantThread.Create; // ̼߳ٶΪݿ߳
  // Create ĲԴ true ʾ߳ڷ com
  // μ˵

  FTestThread1 := TTestThread.Create; // ߳1
  FTestThread1.TagID := 1;
  FTestThread1.SleepTime := 1000; // ģִĺʱ

  FTestThread2 := TTestThread.Create; // ߳2
  FTestThread2.TagID := 2;
  FTestThread2.SleepTime := 1500;

  FTestThread1.OnStatusMsg := self.OnThreadMsg;
  FTestThread1.OnDebugMsg := self.OnThreadMsg; // ˾ʵӦõʱָ⴦
  FTestThread1.OnTest := self.OnTest;

  FTestThread2.OnStatusMsg := self.OnThreadMsg;
  FTestThread2.OnDebugMsg := self.OnThreadMsg; // ˾ʵӦõʱָ⴦
  FTestThread2.OnTest := self.OnTest;

end;

procedure TFrmElegantThread.OnTest(Sender: TTestThread);
begin
  //  queue ýϷ,ݿִ߳
  // Synchronize ִٷأ
  FDataThread.Synchronize(
    procedure
    begin
      // 棬ԷֱݿĴ
      // е̣߳Ҫݿ󣬶
      // FDataThread ߳ڵĴִ
      // ôǷ̻߳ģ̡߳߳Ϳ
      inc(FTaskCode);
      if FTaskCode <= 9 then
      begin
        Sender.TaskCode := FTaskCode; // ʾ쵽
      end
      else
        Sender.TaskCode := 0; // ʾδ쵽
    end);
end;

procedure TFrmElegantThread.OnThreadMsg(AMsg: String);
begin
  // Ϊ˴̴߳룬̴߳з VCL Ҫִ
  // ǰ̴ִ߳߳
  TThread.Synchronize(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
end;

end.
